## ros-indigo-libnabo 1.0.7

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

if (NOT CMAKE_VERSION VERSION_LESS "3.1")
	cmake_policy(SET CMP0054 NEW)
endif ()

set(LIB_NAME nabo)
project("lib${LIB_NAME}")

# Extract version from header
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR})
execute_process(
	COMMAND grep "NABO_VERSION " nabo/nabo.h
	WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
	RESULT_VARIABLE GREP_VERSION_RESULT
	OUTPUT_VARIABLE PROJECT_VERSION
	OUTPUT_STRIP_TRAILING_WHITESPACE
)
if (NOT GREP_VERSION_RESULT EQUAL 0)
	message(SEND_ERROR "Cannot grep version number: ${GREP_VERSION_RESULT}")
endif (NOT GREP_VERSION_RESULT EQUAL 0)
string(REGEX REPLACE ".*\"(.*)\".*" "\\1" PROJECT_VERSION "${PROJECT_VERSION}" )

if (NOT CMAKE_BUILD_TYPE)
	message("-- No build type specified; defaulting to CMAKE_BUILD_TYPE=Release.")
	set(CMAKE_BUILD_TYPE Release CACHE STRING
	  "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
	  FORCE)
else (NOT CMAKE_BUILD_TYPE)
	if (CMAKE_BUILD_TYPE STREQUAL "Debug")
		message("\n=================================================================================")
		message("\n-- Build type: Debug. Performance will be terrible!")
		message("-- Add -DCMAKE_BUILD_TYPE=Release to the CMake command line to get an optimized build.")
		message("\n=================================================================================")
	endif (CMAKE_BUILD_TYPE STREQUAL "Debug")
endif (NOT CMAKE_BUILD_TYPE)

if (NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
	add_definitions(-O3)
endif(NOT CMAKE_BUILD_TYPE STREQUAL "Debug")

# Documentation
set(DOXYFILE_LATEX false)
include(UseDoxygen)

# Switch on warnings.
if (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Wall")
else ()
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra")
endif ()

# Check the compiler version as we need C++11 support.
if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
	# using Clang
	if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS "3.3")
		message(FATAL_ERROR "Your clang compiler has version ${CMAKE_CXX_COMPILER_VERSION}, while version 3.3 or later is required")
	endif ()
elseif (CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
	# using AppleClang
	if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS "5.1")
		message(FATAL_ERROR "Your XCode environment has version ${CMAKE_CXX_COMPILER_VERSION}, while version 5.1 or later is required")
	endif ()
elseif (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
	# using GCC
	if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS "4.8.2")
		message(FATAL_ERROR "Your g++ compiler has version ${CMAKE_CXX_COMPILER_VERSION}, while version 4.8.2 or later is required")
	endif ()
elseif (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
	# using MSVC
	if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS "19.0.23506")
		message(FATAL_ERROR "Your Microsoft Visual C++ compiler has version ${CMAKE_CXX_COMPILER_VERSION}, while version MSVC 2015 Update 1+ is required")
	endif ()
endif ()

# enable C++11 support.
if (CMAKE_VERSION VERSION_LESS "3.1")
	if (MSVC)
		message(FATAL_ERROR "CMake version 3.1 or later is required to compile ${PROJECT_NAME} with Microsoft Visual C++")
	endif ()
	if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
		set (CMAKE_CXX_FLAGS "-std=c++0x ${CMAKE_CXX_FLAGS}")
	else ()
		set (CMAKE_CXX_FLAGS "-std=c++11 ${CMAKE_CXX_FLAGS}")
	endif ()
else ()
	set (CMAKE_CXX_STANDARD 11)
endif ()

# openmp
set(USE_OPEN_MP TRUE CACHE BOOL "Set to FALSE to not use OpenMP")
if (USE_OPEN_MP)
	find_package(OpenMP)
	if (OPENMP_FOUND)
		add_definitions(-fopenmp -DHAVE_OPENMP)
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
		if (CMAKE_COMPILER_IS_GNUCC)
			set(EXTRA_LIBS ${EXTRA_LIBS} gomp)
		endif(CMAKE_COMPILER_IS_GNUCC)
	endif(OPENMP_FOUND)
endif (USE_OPEN_MP)

# eigen 2 or 3
find_path(EIGEN_INCLUDE_DIR Eigen/Core
	/usr/local/include/eigen3
	/usr/local/include/eigen2
	/usr/local/include/eigen
	/usr/include/eigen3
	/usr/include/eigen2
	/usr/include/eigen
	/opt/local/include/eigen3
)

# optionally, opencl
# OpenCL disabled as its code is not up-to-date with API
set(USE_OPEN_CL FALSE CACHE BOOL "Set to TRUE to look for OpenCL")
if (USE_OPEN_CL)
	find_path(OPENCL_INCLUDE_DIR CL/cl.h
		/usr/local/include
		/usr/include
	)
	if (WIN32)
		find_library(OPENCL_LIBRARIES opencl64)
		if (!OPENCL_LIBRARIES)
			find_library(OPENCL_LIBRARIES opencl32)
		endif (!OPENCL_LIBRARIES)
	else (WIN32)
		find_library(OPENCL_LIBRARIES OpenCL ENV LD_LIBRARY_PATH)
	endif (WIN32)
	if (OPENCL_INCLUDE_DIR AND OPENCL_LIBRARIES)
		add_definitions(-DHAVE_OPENCL)
		set(EXTRA_LIBS ${OPENCL_LIBRARIES} ${EXTRA_LIBS})
		include_directories(${OPENCL_INCLUDE_DIR})
		add_definitions(-DOPENCL_SOURCE_DIR=\"${CMAKE_SOURCE_DIR}/nabo/opencl/\")
		message("OpenCL enabled and found, enabling CL support")
	else (OPENCL_INCLUDE_DIR AND OPENCL_LIBRARIES)
		message("OpenCL enabled but not found, disabling CL support")
	endif (OPENCL_INCLUDE_DIR AND OPENCL_LIBRARIES)
else (USE_OPEN_CL)
	message("OpenCL disabled, not looking for it")
endif (USE_OPEN_CL)

# include all libs so far
include_directories(${CMAKE_SOURCE_DIR} ${EIGEN_INCLUDE_DIR})

# main nabo lib
set(NABO_SRC
	nabo/nabo.cpp
	nabo/brute_force_cpu.cpp
	nabo/kdtree_cpu.cpp
	nabo/kdtree_opencl.cpp
)
set(SHARED_LIBS FALSE CACHE BOOL "Set to TRUE to build shared library")
if (SHARED_LIBS)
	add_library(${LIB_NAME} SHARED ${NABO_SRC})
	install(TARGETS ${LIB_NAME} LIBRARY DESTINATION lib)
else (SHARED_LIBS)
	add_library(${LIB_NAME} ${NABO_SRC})
	add_definitions(-fPIC)
	install(TARGETS ${LIB_NAME} ARCHIVE DESTINATION lib)
endif (SHARED_LIBS)
set_target_properties(${LIB_NAME} PROPERTIES VERSION "${PROJECT_VERSION}" SOVERSION 1)

# create doc before installing
set(DOC_INSTALL_TARGET "share/doc/${PROJECT_NAME}/api" CACHE STRING "Target where to install doxygen documentation")
install(FILES nabo/nabo.h DESTINATION include/nabo)
install(FILES nabo/third_party/any.hpp DESTINATION include/nabo/third_party)
install(FILES README.md DESTINATION share/doc/${PROJECT_NAME})
if (DOXYGEN_FOUND)
	install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/doc/html DESTINATION ${DOC_INSTALL_TARGET})
endif (DOXYGEN_FOUND)

enable_testing()

add_subdirectory(examples)
add_subdirectory(tests)
add_subdirectory(python)

# Install catkin package.xml
install(FILES package.xml DESTINATION share/libnabo)

#=============================================
# to allow find_package() on libnabo
#=============================================
# 
# the following case be used in an external project requiring libnabo:
#  ...
#  find_package(libnabo) 
#  include_directories(${libnabo_INCLUDE_DIRS}) 
#  target_link_libraries(executableName ${libnabo_LIBRARIES})
#  ...

# NOTE: the following will support find_package for 1) local build (make) and 2) for installed files (make install)

# 1- local build #

# Register the local build in case one doesn't use "make install"
export(PACKAGE libnabo)

# Create variable with the library location
set(libnabo_library $<TARGET_FILE:${LIB_NAME}>)

# Create variable for the local build tree
get_property(libnabo_include_dirs DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY INCLUDE_DIRECTORIES)
# Configure & generate config file for local build tree
configure_file(libnaboConfig.cmake.in
	"${PROJECT_BINARY_DIR}/libnaboConfig.cmake.conf" @ONLY)
file(GENERATE
	OUTPUT "${PROJECT_BINARY_DIR}/libnaboConfig.cmake"
	INPUT "${PROJECT_BINARY_DIR}/libnaboConfig.cmake.conf")

# 2- installation build #

# Change the library location for an install location
set(libnabo_library ${CMAKE_INSTALL_PREFIX}/lib/$<TARGET_FILE_NAME:${LIB_NAME}>)

# Change the include location for the case of an install location
set(libnabo_include_dirs ${CMAKE_INSTALL_PREFIX}/include)

# We put the generated file for installation in a different repository (i.e., ./CMakeFiles/)
configure_file(libnaboConfig.cmake.in
	"${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/libnaboConfig.cmake.conf" @ONLY)
file(GENERATE
	OUTPUT "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/libnaboConfig.cmake"
	INPUT "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/libnaboConfig.cmake.conf")

# The same versioning file can be used for both cases
configure_file(libnaboConfigVersion.cmake.in
	"${PROJECT_BINARY_DIR}/libnaboConfigVersion.cmake" @ONLY)

install(FILES
	"${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/libnaboConfig.cmake"
	"${PROJECT_BINARY_DIR}/libnaboConfigVersion.cmake"
	DESTINATION share/libnabo/cmake COMPONENT dev)


#=============================================
# Add uninstall target
#=============================================
configure_file(
	"${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
	"${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
	IMMEDIATE @ONLY)

add_custom_target(uninstall
	COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

=== debian/changelog ===
ros-indigo-libnabo (1.0.7-0trusty) trusty; urgency=high

  * Disabled cmake compile tests by default and on compilers that do not support them (#95)
  * Fix Python 2 bindings support in CMake scripts (#90)
  * Port libnabo to c++11 (#89)
  * Remove register keyword in index_heap.h (#88)
  * Fix compilation warning for MSVC (#85)
  * Assert template type for invalid setters (#80)
  * Return numerically maximal index (unsigned) or -1 (signed) for no match case (#79)
  * Add generate step for ${PROJECT_BINARY_DIR}/libnaboConfig.cmake (#76)
  * Removed compiler-specific flags for compilers that do not support them (#74)
  * Added cmake_policy(SET CMP0054 NEW) (#73)
  * Output compiler message with compile test fatal error in cmake (#72)
  * Removed erroneous commas from test/CMakeLists.txt (#71)
  * Removed fatal "," suffix from FATAL_ERROR in CMakeLists.txt (#70)
  * Fixed regression concerning installed libnaboConfig.cmake (#65)
  * Fix/relax compiler requirements (#63)
  * Removed hard dependency on the doc target (#62)
  * Install any.hpp (#61)
  * Remove boost::any and boost:format dependencies (#59)
  * Port the python bindings to python3 (#57)
  * Added cmake switch to disable usage of OpenMP (#53)
  * Zero copy for Eigen::Matrix3XT and Eigen::Map<const Eigen::Matrix3XT> (#43)
  * Fix warnings and switch on Wextra (#42)
  * Disallow instantiation with non dynamic matrices (#41)
  * Update README.md
  * Removed all code dealing with libnaboTargets.cmake (#32)
  * Got rid of unused locally defined typedefs (#27)
  * Contributors: David Landry, Hannes Sommer, Simon Lynen, Simon-Pierre Deschênes, Stéphane Magnenat, cezheng, ffurrer, magehrig, renning22, sandsmark, taketwo, tcies

 -- Stéphane Magnenat <stephane.magnenat@mavt.ethz.ch>  Thu, 07 Feb 2019 05:00:00 -0000

ros-indigo-libnabo (1.0.6-0trusty) trusty; urgency=high

  * Reset point indices of results with distances exceeding threshold (#23, #24)
  * Fine tune the find_package() capability and add uninstall target (#22)
  * Fixed compiler warning (#18)
  * Added OpenMP support (#20, #21)
  * Build type tuning (#19)
  * Fix: terminal comma in enum requires C++11
  * Fix UBSAN error calculating maxNodeCount (#16, #17)
  * Fixed tiny (yet significant) error in the Python doc strings (#15)
  * Compile static lib with PIC (#14)
  * Contributors: Francois Pomerleau, François Pomerleau, Gregory Hitz, Gregory Jefferis, Simon Lynen, Stéphane Magnenat

 -- Stéphane Magnenat <stephane.magnenat@mavt.ethz.ch>  Thu, 05 Mar 2015 05:00:00 -0000

ros-indigo-libnabo (1.0.5-0trusty) trusty; urgency=high

  * Added configure scripts for full catkinization
  * Catkinization of libnabo (following REP136)
  * Update README.md
    Added Simon as the maintainer.
  * [test] use CLOCK_PROF for NetBSD build
  * Fixed CppCheck warning.
    Fix broken install when doxygen is not found
  * Fix cmake stylistic issue
  * Make python install respect custom CMAKE_INSTALL_PREFIX
  * Fix broken install when doxygen is not found
  * Contributors: Chris Foster, Francis Colas, Paul Furgale, Pierrick Koch, Stéphane Magnenat, fcolas

 -- Stéphane Magnenat <stephane.magnenat@mavt.ethz.ch>  Thu, 12 Jun 2014 04:00:00 -0000

ros-indigo-libnabo (1.0.4-0trusty) trusty; urgency=high

  * Updated Debian version number.
  * Added check for invalid optionFlags values.
  * Fixed compilation on OS X, reduced code duplication in tests by moving timers into helpers.h
  * Contributors: Stéphane Magnenat

 -- Stéphane Magnenat <stephane.magnenat@mavt.ethz.ch>  Tue, 03 Sep 2013 04:00:00 -0000

ros-indigo-libnabo (1.0.3-0trusty) trusty; urgency=high

  * Prevent requesting more points than available in the cloud, prevent the use of empty clouds, bumped version number.
  * Added test for grep.
  * Worked around issue #3 <https://github.com/ethz-asl/libnabo/issues/3> on Windows.
  * Updated documentation.
  * Contributors: Stéphane Magnenat

 -- Stéphane Magnenat <stephane.magnenat@mavt.ethz.ch>  Mon, 19 Aug 2013 04:00:00 -0000

ros-indigo-libnabo (1.0.2-0trusty) trusty; urgency=high

  * Updated version number.
  * Added const
  * Removed useless optimisation, cleaned-up.
  * faster tree heap when less neighbors than requested
  * Hopefully fixed detection of missmatched python versions.
  * Fixed cloud size check for clouds with billions of points.
  * Contributors: Francis Colas, Stéphane Magnenat

 -- Stéphane Magnenat <stephane.magnenat@mavt.ethz.ch>  Wed, 20 Feb 2013 05:00:00 -0000

ros-indigo-libnabo (1.0.1-0trusty) trusty; urgency=high

  * Bumped version in doc.
  * Updated documentation to reflect the disabling of OpenCL.
  * Fixed bug in version define.
  * Typo.
  * Added note about nabo citation.
  * Fixed the semantic of epsilon to match the documentation's and ANN's ones.
  * Added ability to pass one radius per point.
  * Added custom command for python target.
  * Reverted buggy change
  * Fixed old python_add_module
  * fixed python 2.6 detection on debian.
  * Fixed debian installation.
  * Added debian-specific install target.
  * Fixed doc and python link command
  * Added docstring to python bindings.
  * Added test and improved CMakeLists.txt
  * Added debian install for python
  * Renammed to pynabo, added python install script.
  * Experimental python bindings working.
  * When number of point is smaller than bucket size, create a single-bucket tree.
  * Cleaned-up makefile.
  * Fixed description.
  * Merge branch 'master' of github.com:ethz-asl/libnabo
  * Added dbg package.
  * Contributors: Stéphane Magnenat

 -- Stéphane Magnenat <stephane.magnenat@mavt.ethz.ch>  Tue, 06 Nov 2012 05:00:00 -0000

ros-indigo-libnabo (1.0.0-0trusty) trusty; urgency=high

  * Fixed naming convention.
  * Removed dbg msg.
  * Fixed doc.
  * Updated doc, fixed debian build.
  * Updated README.
  * Fixed debian compilation.
  * Added note about download.
  * Fixed bug in control file.
  * Separated doc package from dev package.
  * Cleaned-up debian build chain.
  * Added debian package.


=== debian/control ===
Source: ros-indigo-libnabo
Section: misc
Priority: extra
Maintainer: Stéphane Magnenat <stephane.magnenat@mavt.ethz.ch>
Build-Depends: debhelper (>= 9.0.0), cmake, libboost-all-dev, libeigen3-dev
Homepage: 
Standards-Version: 3.9.2

Package: ros-indigo-libnabo
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libeigen3-dev, ros-indigo-catkin
Description: libnabo is a fast K Nearest Neighbour library for low-dimensional spaces.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-libnabo//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
